GNU bug report logs - #20990
RFC: [PATCH] accept new option: --files0-from=F

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: grep; Severity: wishlist; Reported by: Jim Meyering <jim@HIDDEN>; Keywords: wontfix patch; dated Mon, 6 Jul 2015 03:34:02 UTC; Maintainer for grep is bug-grep@HIDDEN.
Severity set to 'wishlist' from 'normal' Request was from Paul Eggert <eggert@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) wontfix. Request was from Paul Eggert <eggert@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 20990 <at> debbugs.gnu.org:


Received: (at 20990) by debbugs.gnu.org; 15 Aug 2016 22:56:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Aug 15 18:56:17 2016
Received: from localhost ([127.0.0.1]:58635 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1bZQnp-0002uD-2o
	for submit <at> debbugs.gnu.org; Mon, 15 Aug 2016 18:56:17 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:48248)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1bZQnn-0002u1-HV
 for 20990 <at> debbugs.gnu.org; Mon, 15 Aug 2016 18:56:15 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 2D1B41610EC;
 Mon, 15 Aug 2016 15:56:10 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id fwdTcP4A1Mdy; Mon, 15 Aug 2016 15:56:09 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 820C7161160;
 Mon, 15 Aug 2016 15:56:09 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id tzUgd2uaWgHY; Mon, 15 Aug 2016 15:56:09 -0700 (PDT)
Received: from [192.168.1.9] (unknown [100.32.155.148])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 63D171610EC;
 Mon, 15 Aug 2016 15:56:09 -0700 (PDT)
To: Jim Meyering <jim@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Subject: Re: RFC: [PATCH] accept new option: --files0-from=F
Organization: UCLA Computer Science Department
Message-ID: <e004bfd0-2d78-92cc-563a-9ddb20ba1bc4@HIDDEN>
Date: Mon, 15 Aug 2016 15:56:09 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:45.0) Gecko/20100101
 Thunderbird/45.2.0
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 20990
Cc: 20990 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

No further comments for a year, so I'll mark this as wontfix for now.




Information forwarded to bug-grep@HIDDEN:
bug#20990; Package grep. Full text available.

Message received at 20990 <at> debbugs.gnu.org:


Received: (at 20990) by debbugs.gnu.org; 6 Jul 2015 16:03:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 06 12:03:20 2015
Received: from localhost ([127.0.0.1]:42314 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZC8rY-0007hS-4F
	for submit <at> debbugs.gnu.org; Mon, 06 Jul 2015 12:03:20 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:58375)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <eggert@HIDDEN>) id 1ZC8rV-0007du-6s
 for 20990 <at> debbugs.gnu.org; Mon, 06 Jul 2015 12:03:18 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 08CC31608FB;
 Mon,  6 Jul 2015 09:03:11 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id N7_DtdjP4_vf; Mon,  6 Jul 2015 09:03:10 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 5A8AD1608D4;
 Mon,  6 Jul 2015 09:03:10 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id KTmu4u8nN9vV; Mon,  6 Jul 2015 09:03:10 -0700 (PDT)
Received: from [192.168.1.9] (pool-100-32-155-148.lsanca.fios.verizon.net
 [100.32.155.148])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 3D87F16019C;
 Mon,  6 Jul 2015 09:03:10 -0700 (PDT)
Message-ID: <559AA6B0.9020905@HIDDEN>
Date: Mon, 06 Jul 2015 09:02:56 -0700
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
 rv:31.0) Gecko/20100101 Thunderbird/31.7.0
MIME-Version: 1.0
To: Jim Meyering <jim@HIDDEN>, 20990 <at> debbugs.gnu.org
Subject: Re: bug#20990: RFC: [PATCH] accept new option: --files0-from=F
References: <CA+8g5KEF_Y9me3sw7oWf6g=Zt1E0SMNJA28ywJ1yUR6jiHKdsg@HIDDEN>
 <CA+8g5KFR58Dw3pZS7CTe64z+0tkNmrH3XYLW8Jnhuw-BfobEqQ@HIDDEN>
In-Reply-To: <CA+8g5KFR58Dw3pZS7CTe64z+0tkNmrH3XYLW8Jnhuw-BfobEqQ@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 20990
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

Jim Meyering wrote:
> Now that I've removed those bits of justification, I'll have to
> think more about whether it's worth adding this.

Not much justification left, if you ask me (which you don't have to :-).





Information forwarded to bug-grep@HIDDEN:
bug#20990; Package grep. Full text available.

Message received at 20990 <at> debbugs.gnu.org:


Received: (at 20990) by debbugs.gnu.org; 6 Jul 2015 13:57:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 06 09:57:48 2015
Received: from localhost ([127.0.0.1]:42190 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZC6u3-0003Ai-8R
	for submit <at> debbugs.gnu.org; Mon, 06 Jul 2015 09:57:47 -0400
Received: from mail-yk0-f170.google.com ([209.85.160.170]:35222)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <meyering@HIDDEN>) id 1ZC6u0-0003AR-G2
 for 20990 <at> debbugs.gnu.org; Mon, 06 Jul 2015 09:57:45 -0400
Received: by ykfs198 with SMTP id s198so43778335ykf.2
 for <20990 <at> debbugs.gnu.org>; Mon, 06 Jul 2015 06:57:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:in-reply-to:references:from:date:message-id
 :subject:to:content-type;
 bh=J08sK+FcYFiNchCGRcSPFdVz7cNVG0tOsGe4th37Vgc=;
 b=ebDedezOLZQpehh4Sw3gsPiu83TLMX7dL+pTr0xeHNSMF1kUbF4zy/lkaU+urJsq3k
 i1euZqTUBzQdHr8CcAKKETOwnXYvuDx5jgrcOuvypyjCJm17W+Tuqfdl+UmJibERyFm/
 qHfm8AbUj94Tize8IW8Wb0OP69R+TR4S/PK6em1r+NmqQ3SHeSi/yXYtZLxgCsQ2f2tv
 VPP66yiZ2EzlbTMuJAoK/dcmefVHVu2a15p+DWJdfWUCIzb9keMlAwYpvnRxG8+/TTaX
 jqsx+ouTXK/aADufiFOXUIvsEjFGoKaDGKsYePzobaJx0dW3H8jsFFdJJ7AYmEO4kz/B
 lYIQ==
X-Received: by 10.170.79.5 with SMTP id v5mr27443336ykv.15.1436191058746; Mon,
 06 Jul 2015 06:57:38 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.37.201.66 with HTTP; Mon, 6 Jul 2015 06:57:19 -0700 (PDT)
In-Reply-To: <CA+8g5KEF_Y9me3sw7oWf6g=Zt1E0SMNJA28ywJ1yUR6jiHKdsg@HIDDEN>
References: <CA+8g5KEF_Y9me3sw7oWf6g=Zt1E0SMNJA28ywJ1yUR6jiHKdsg@HIDDEN>
From: Jim Meyering <jim@HIDDEN>
Date: Mon, 6 Jul 2015 06:57:19 -0700
X-Google-Sender-Auth: qzrfakZMtEpOTvZYAcpxUFOpCUE
Message-ID: <CA+8g5KFR58Dw3pZS7CTe64z+0tkNmrH3XYLW8Jnhuw-BfobEqQ@HIDDEN>
Subject: Re: bug#20990: RFC: [PATCH] accept new option: --files0-from=F
To: 20990 <at> debbugs.gnu.org
Content-Type: text/plain; charset=UTF-8
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 20990
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On Sun, Jul 5, 2015 at 8:32 PM, Jim Meyering <jim@HIDDEN> wrote:
> Here is a patch to teach grep the --files0-from=F option.
> That is the same option that is already supported by wc, du and sort
> in the GNU coreutils.
>
> This option allows one to specify NUL-separated file names in the file
> argument, F.  When I would receive requests to add this option to other
> programs from the coreutils, I would refuse, because one can obtain
> similar behavior by using xargs like this:
>
>   xargs -0 PROGRAM < F
>
> The "use xargs" argument does not work for programs like wc, du and sort.
> In those cases, concatenating the output from multiple invocations
> (as that xargs usage would do) does not result in the same output as
> using --files0-from=F, e.g., because of totals or, for sort, because
> the result cannot be the concatenation of separately-sorted outputs.
>
> For most uses of grep, it would be ok to process separate lists of
> file names in batches and to concatenate the results, but not with
> the --count (-c) option.  The count must reflect the total over
> all files processed.

Hmm... *this* --count option does not have that behavior, so it's
not a good justification. This is a per-file and per-output-line count.

> Also, more subtly, consider what would happen when the last batch of file
> name inputs to xargs happens to contain only one name. The output from
> that final invocation of grep (assuming no option like -h or -H) would
> omit the "FILENAME:" prefix for any lines matched from that final file.

And in this case, simply adding '/dev/null' or using -h ensures that
even that unusual case will be handled properly.

Now that I've removed those bits of justification, I'll have to
think more about whether it's worth adding this.




Information forwarded to bug-grep@HIDDEN:
bug#20990; Package grep. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 6 Jul 2015 03:33:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 05 23:33:09 2015
Received: from localhost ([127.0.0.1]:41274 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ZBx9T-0000zn-12
	for submit <at> debbugs.gnu.org; Sun, 05 Jul 2015 23:33:08 -0400
Received: from eggs.gnu.org ([208.118.235.92]:43513)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <meyering@HIDDEN>) id 1ZBx9N-0000zK-Bw
 for submit <at> debbugs.gnu.org; Sun, 05 Jul 2015 23:33:00 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1ZBx9F-0007Td-Nu
 for submit <at> debbugs.gnu.org; Sun, 05 Jul 2015 23:32:52 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:43074)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1ZBx9F-0007TZ-LX
 for submit <at> debbugs.gnu.org; Sun, 05 Jul 2015 23:32:49 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:57019)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1ZBx9D-0002Kx-4p
 for bug-grep@HIDDEN; Sun, 05 Jul 2015 23:32:49 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1ZBx9A-0007Sa-ET
 for bug-grep@HIDDEN; Sun, 05 Jul 2015 23:32:47 -0400
Received: from mail-yk0-x232.google.com ([2607:f8b0:4002:c07::232]:34359)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <meyering@HIDDEN>) id 1ZBx9A-0007SP-7f
 for bug-grep@HIDDEN; Sun, 05 Jul 2015 23:32:44 -0400
Received: by ykfy125 with SMTP id y125so137900773ykf.1
 for <bug-grep@HIDDEN>; Sun, 05 Jul 2015 20:32:43 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:sender:from:date:message-id:subject:to:content-type;
 bh=vce2Fil+5S1Fmzd2p4eGiKzYStvG5BKirTOzzljxnT8=;
 b=mwv9LSnUFCx65x8z47A52rKfjH1N63tBRA0gCgX+coZbmKe34t6okD+05ZmT8q0Ti1
 VheHXhGoy0jk17vNw+1iuxbrvLHDcy0gT26nIO+6xeV9CGsvheD1H6bgBl02FsDHXAFi
 3p87ItQBPf0o3KJ+6XBNimfLdaStXy0aQBQtcdyM7Wgdj1ne10PFyagYmylIf+L4G/DS
 P68dF+g56UDt9IVMKoQA3ky1qxkVWeSXys0fEotlOYcIR9RRZK9nLqS+1FE3rdvi6yo2
 13LNAo0lyx7mDBCkirTkWEm30FknmXxZ7zThLejJpZ5dASnFQ5OzWzz1edCzUWuxfWEn
 yLaA==
X-Received: by 10.170.94.84 with SMTP id l81mr56297635yka.101.1436153563574;
 Sun, 05 Jul 2015 20:32:43 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.37.201.66 with HTTP; Sun, 5 Jul 2015 20:32:23 -0700 (PDT)
From: Jim Meyering <jim@HIDDEN>
Date: Sun, 5 Jul 2015 20:32:23 -0700
X-Google-Sender-Auth: 4eYyo6-3o_4OiLKTS3HaC-B7loE
Message-ID: <CA+8g5KEF_Y9me3sw7oWf6g=Zt1E0SMNJA28ywJ1yUR6jiHKdsg@HIDDEN>
Subject: RFC: [PATCH] accept new option: --files0-from=F
To: bug-grep@HIDDEN
Content-Type: multipart/mixed; boundary=001a113a6cb600a5ba051a2c8f3e
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

--001a113a6cb600a5ba051a2c8f3e
Content-Type: text/plain; charset=UTF-8

Here is a patch to teach grep the --files0-from=F option.
That is the same option that is already supported by wc, du and sort
in the GNU coreutils.

This option allows one to specify NUL-separated file names in the file
argument, F.  When I would receive requests to add this option to other
programs from the coreutils, I would refuse, because one can obtain
similar behavior by using xargs like this:

  xargs -0 PROGRAM < F

The "use xargs" argument does not work for programs like wc, du and sort.
In those cases, concatenating the output from multiple invocations
(as that xargs usage would do) does not result in the same output as
using --files0-from=F, e.g., because of totals or, for sort, because
the result cannot be the concatenation of separately-sorted outputs.

For most uses of grep, it would be ok to process separate lists of
file names in batches and to concatenate the results, but not with
the --count (-c) option.  The count must reflect the total over
all files processed.

Also, more subtly, consider what would happen when the last batch of file
name inputs to xargs happens to contain only one name. The output from
that final invocation of grep (assuming no option like -h or -H) would
omit the "FILENAME:" prefix for any lines matched from that final file.

This patch depends on the perl-based test infrastructure I have just
posted, because the tests are very similar to those for the three tools
from the coreutils.

--001a113a6cb600a5ba051a2c8f3e
Content-Type: text/x-patch; charset=US-ASCII; 
	name="0001-accept-new-option-files0-from-F.patch"
Content-Disposition: attachment; 
	filename="0001-accept-new-option-files0-from-F.patch"
Content-Transfer-Encoding: base64
X-Attachment-Id: f_ibratev60
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--001a113a6cb600a5ba051a2c8f3e--




Acknowledgement sent to Jim Meyering <jim@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-grep@HIDDEN. Full text available.
Report forwarded to bug-grep@HIDDEN:
bug#20990; Package grep. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 25 Nov 2019 12:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.